# GET /coupon/{{product_id}} — List All Coupons By Product

> Product: **Pabbly Subscription Billing** (v1)
> Base URL: `https://payments.pabbly.com/api/v1`
> Auth: Basic via `Authorization` header
> Canonical: `/subscription-billing/coupon/list-all-coupons-by-product`

This API is used to retrieve a list of all the available coupons by product id.

**Path parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| product_id | string | Yes |  |

**Query parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| limit | string | No | Integer, default=10, min=1, max=100 The number of resources to be returned. |
| page | string | No | By default first page will be listed. For navigating through pages, use the page parameter. |

**Response (200)** — Get Coupon:

```json
{
    "status": "success",
    "message": "Get Coupon",
    "data": [
        {
            "status": "active",
            "apply_to": "total_amount",
            "createdAt": "2020-03-04T05:25:50.089Z",
            "updatedAt": "2020-03-04T05:25:50.089Z",
            "id": "5e5f3bde7c5aeb3675f41685",
            "product_id": "5e3a95143c92e44b424b6d47",
            "coupon_name": "Special Offer",
            "coupon_code": "SPL-OFF",
            "discount": 25,
            "discount_type": "flat",
            "redemption_type": "number_time",
            "redemption_cycle": 2,
            "associate_plans": "selected_plans",
            "plans_array": [
                "5e3bf8b8db85462760295d2f",
                "5e3aa7133c92e44b424b6dec"
            ],
            "valid_upto": "2022-10-02",
            "maximum_redemption": 10,
            "used_redemption": 0
        },
        {
            "status": "active",
            "apply_to": "total_amount",
            "createdAt": "2020-02-05T10:36:25.297Z",
            "updatedAt": "2020-02-05T10:36:25.297Z",
            "id": "5e3a9aa924b63d4b28410cc7",
            "product_id": "5e3a95143c92e44b424b6d47",
            "coupon_name": "Percentage Recurring",
            "coupon_code": "PER",
            "discount": 10,
            "discount_type": "percent",
            "redemption_type": "forever",
            "redemption_cycle": 0,
            "associate_plans": "all_plans",
            "plans_array": null,
            "valid_upto": "2020-03-11",
            "maximum_redemption": 5,
            "used_redemption": 4
        },
        {
            "status": "active",
            "apply_to": "total_amount",
            "createdAt": "2020-02-05T10:29:15.945Z",
            "updatedAt": "2020-02-05T10:29:15.945Z",
            "id": "5e3a98fb3c92e44b424b6d77",
            "product_id": "5e3a95143c92e44b424b6d47",
            "coupon_name": "Flat Coupon onetime",
            "coupon_code": "FLAT",
            "discount": 5,
            "discount_type": "flat",
            "redemption_type": "onetime",
            "redemption_cycle": 0,
            "associate_plans": "selected_plans",
            "plans_array": [
                "5e3a95303c92e44b424b6d48"
            ],
            "valid_upto": "2020-02-05",
            "maximum_redemption": 5,
            "used_redemption": 3
        }
    ]
}
```

**Code examples:**

_cURL_

```curl
curl https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}} \
  -u {{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}
```

_Ruby_

```ruby
require 'net/http'
require 'json'

uri = URI('https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}')
request = Net::HTTP::Get.new(uri)
request.basic_auth '{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == 'https') do |http|
  http.request(request)
end

data = JSON.parse(response.body)
```

_Python_

```python
import requests
from requests.auth import HTTPBasicAuth

response = requests.get(
    'https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}',
    auth=HTTPBasicAuth('{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'),
)

data = response.json()
```

_PHP_

```php
<?php
$ch = curl_init('https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_USERPWD, '{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}');

$response = curl_exec($ch);
curl_close($ch);
$data = json_decode($response, true);
```

_Java_

```java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.Base64;

String credentials = Base64.getEncoder().encodeToString("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}".getBytes());

HttpClient client = HttpClient.newHttpClient();
HttpRequest.Builder builder = HttpRequest.newBuilder()
    .uri(URI.create("https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}"))
    .header("Authorization", "Basic " + credentials)
    .GET();

HttpRequest request = builder.build();
HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());
```

_Node.js_

```node
const credentials = Buffer.from('{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}').toString('base64');

const response = await fetch('https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}', {
  method: 'GET',
  headers: {
    'Authorization': `Basic ${credentials}`,
  },
});

const data = await response.json();
```

_Go_

```go
package main

import (
    "fmt"
    "io"
    "net/http"
)

func main() {
    req, _ := http.NewRequest("GET", "https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}", nil)
    req.SetBasicAuth("{{YOUR_API_KEY}}", "{{YOUR_SECRET_KEY}}")

    res, _ := http.DefaultClient.Do(req)
    defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)
    fmt.Println(string(body))
}
```

_.NET_

```dotnet
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

var credentials = Convert.ToBase64String(Encoding.ASCII.GetBytes("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}"));

var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Get, "https://payments.pabbly.com/api/v1/coupon/{{product_id}}?limit={{limit}}&page={{page}}");
request.Headers.TryAddWithoutValidation("Authorization", $"Basic {credentials}");

var response = await client.SendAsync(request);
var data = await response.Content.ReadAsStringAsync();
Console.WriteLine(data);
```

---

**Other endpoints in Coupon:**

- [POST /coupon/{{product_id}} — Create Coupon](/subscription-billing/coupon/create-coupon)
- [DELETE /coupons/{{coupon_id}} — Delete Coupon](/subscription-billing/coupon/delete-coupon)
- [PUT /coupons/{{coupon_id}} — Update Coupon](/subscription-billing/coupon/update-coupon)

